hdu 5294(最短+最大流)


Tricks Device
Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 3095    Accepted Submission(s): 835
Problem Description
Innocent Wu follows Dumb Zhang into a ancient tomb. Innocent Wu’s at the entrance of the tomb while Dumb Zhang’s at the end of it. The tomb is made up of many chambers, the total number is N. And there are M channels connecting the chambers. Innocent Wu wants to catch up Dumb Zhang to find out the answers of some questions, however, it’s Dumb Zhang’s intention to keep Innocent Wu in the dark, to do which he has to stop Innocent Wu from getting him. Only via the original shortest ways from the entrance to the end of the tomb costs the minimum time, and that’s the only chance Innocent Wu can catch Dumb Zhang.
Unfortunately,Dumb Zhang masters the art of becoming invisible(奇門遁甲)and tricks devices of this tomb, he can cut off the connections between chambers by using them. Dumb Zhang wanders how many channels at least he has to cut to stop Innocent Wu. And Innocent Wu wants to know after how many channels at most Dumb Zhang cut off Innocent Wu still has the chance to catch Dumb Zhang.
 
Input
There are multiple test cases. Please process till EOF.
For each case,the first line must includes two integers, N(<=2000), M(<=60000). N is the total number of the chambers, M is the total number of the channels.
In the following M lines, every line must includes three numbers, and use ai、bi、li as channel i connecting chamber ai and bi(1<=ai,bi<=n), it costs li(0 The entrance of the tomb is at the chamber one, the end of tomb is at the chamber N.

 
Output
Output two numbers to stand for the answers of Dumb Zhang and Innocent Wu’s questions.
 
Sample Input
 
   
8 9 1 2 2 2 3 2 2 4 1 3 5 3 4 5 4 5 8 1 1 6 2 6 7 5 7 8 1
 

Sample Output
 
   
2 6

题意:给定一个无向图,从起点到终点,只有走最短路!!!(这句话非常重要)才能在规定时限内到达,问最少去掉几条边使不能到达,最多去掉几条边仍能到达。

思路:由于是走最短路才能到达,首先的预处理就是求最短路!求出来最短路之后,把所有最短路的边添加到图里面,然后再在这个新建的图上进行操作,最少去掉几条边就是求边权值都相等的最大流,最多去掉几条边就是求边权值都相等的最短路!!这题的主要考点就是在最短路上面!!预处理非常重要。。。这题由于没搞清楚要走最短路wa哇傻了。。


#include 
#include 
#include 
#include
#include
#include
#include
using namespace std;
typedef long long ll;
const   int oo=1e9;
/**oo      */
const  int mm=111111111;
/**mm         ,         ,           */
const  int mn=2010;
/**mn         */
int node,src,dest,edge;
/**node      ,src     ,dest     ,edge     */
int ver[mm],flow[mm],nex[mm];
/**ver       ,flow      ,next        */
int head[mn],work[mn],dis[mn],q[mn];
void prepare(int _node, int _src,int _dest)
{
    node=_node,src=_src,dest=_dest;
    for(int i=0; i=0; i=nex[i])
            if(flow[i]&&dis[v=ver[i]]<0)
            {
                /**          */
                dis[q[r++]=v]=dis[u]+1;
                if(v==dest)  return 1;
            }
    return 0;
}
/**           ,        ,    */
int Dinic_dfs(  int u, int exp)
{
    if(u==dest)  return exp;
    /**work       ,    i    ,           */
    for(  int &i=work[u],v,tmp; i>=0; i=nex[i])
        if(flow[i]&&dis[v=ver[i]]==dis[u]+1&&(tmp=Dinic_dfs(v,min(exp,flow[i])))>0)
        {
            flow[i]-=tmp;
            flow[i^1]+=tmp;
            /**        */
            return tmp;
        }
    return 0;
}

int Dinic_flow()
{
    int i,ret=0,delta;
    while(Dinic_bfs())
    {
        for(i=0; iq;
    for (int i=0; i<=n; i++)
        di[i]=oo;
    memset(vis,0,sizeof(vis));
    q.push(s);
    di[s]=0;
    while(!q.empty())
    {
        int h=q.front();
        q.pop();
        vis[h]=0;
        for (int i=hea[h]; i!=-1; i=x[i].next)
        {
            int v=x[i].to;
            int w=x[i].w;
            if (di[v]>di[h]+w)
            {
                di[v]=di[h]+w;
                if (!vis[v])
                {
                    vis[v]=1;
                    q.push(v);
                }
            }
        }
    }
}
int ip=0;
void add(int u,int v,int w)
{
    x[ip].to=v,x[ip].w=w,x[ip].next=hea[u],hea[u]=ip++;
}

int main()
{
    int n,m;
    while(~scanf("%d%d",&n,&m))
    {
        ip=0;
        memset(hea,-1,sizeof(hea));
        for(int i=0; i